--- Demonstration of terminal input/output
module examples.SimpleIO where


main _ = forever interaction 
            `catch` eof
            `finally` println "See you again."
    where
        interaction = do
            reply <- prompt "Enter a number: "
            case reply.integer of
                Left _  -> println ("`" ++ reply ++ "` is not a number.")
                Right n -> println (show n ++ " is " 
                                    ++ (if even n then "even" else "odd")
                                    ++ ".")
        prompt s = do
            stdout.print s
            stdout.flush
            getLine
        eof :: EOFException -> IO ()
        eof _ = print "Good bye. "
             
