--- Java classes from package @java.util.zip@

module frege.java.util.Zip where

import Java.Util

data ZipException = pure native java.util.zip.ZipException
derive Exceptional ZipException


data ZipFile = mutable native java.util.zip.ZipFile where
    native new     :: MutableIO File -> IO ZipFile throws ZipException, IOException
    native entries :: ZipFile -> IOMutable (Enumeration ZipEntry)
    native getInputStream :: ZipFile -> ZipEntry -> IO InputStream throws IOException
    
data ZipEntry = mutable native java.util.zip.ZipEntry where
    native getName      :: ZipEntry -> IO String
    native isDirectory  :: ZipEntry -> IO Bool 
    